chrome.contextMenus.create({
	"title":chrome.i18n.getMessage('context_QPush'),
	"contexts":["all"],
	"onclick": menuClick
});
function menuClick(info,tab){
	if(info.selectionText) {
		var msg={'text':info.selectionText};
		var gaLabel='selection';
	}
	else if(info.linkUrl) {
		var msg={'text':info.linkUrl};
		var gaLabel='link';
	}
	else {
		var msg={
			'text':info.pageUrl,
			'type':'url',
			'extra':{
				'title':tab.title
			}
		};
		var gaLabel='page';
	}
	PF.gaEvent('context','click',gaLabel);
	PF.reloadStorage(function(){
		sendMsg(msg);
	});
}
function sendMsg(msg){
	if(!pushee_default.get('name')){
		alert(chrome.i18n.getMessage('context_err_nodefault'));
		return false;
	}

	PF.showPageModal('sending');
	PF.ajaxPost('push/',{
		'pusher_id':pusher_id,
		'name':pushee_default.get('name'),
		'sig':pushee_default.get('sig'),
		'msg':msg,
	},function(rd){
		PF.showPageModal('success');
		setTimeout(function(){
			PF.hidePageModal();
		},1200);
		PF.gaEvent('context','submit','success');
	},function(err){
		PF.hidePageModal();
		if(err=='auth'){
			alert(chrome.i18n.getMessage('context_err_auth'));
		}
		else{
			var ans=confirm(chrome.i18n.getMessage('context_err_retry'));
			if(ans){
				sendMsg(msg);
			}
		}
		PF.gaEvent('context','submit','failed-'+err);
	});
}