var PF={
	reloadStorage:function(callback){
		pushee_default=new class_pushee();
		pushee_list=new class_pusheeList();
		chrome.storage.sync.get([
			'pusher_id',
			'pusher_sig',
			'pushee_list',
			'pushee_default',
			'cache_msg'
		],function(item){
			pusher_id=item.pusher_id;
			pusher_sig=item.pusher_sig;
			cache_msg=item.cache_msg;
			var list=item.pushee_list?$.parseJSON(item.pushee_list):[];
			if(list && list.length>0){
				var defaultInList=false;
				for(var i=0;i<list.length;i++){
					pushee_list.add(new class_pushee({
						'name':list[i]["name"],
						'code':list[i]["code"],
						'sig':list[i]['sig'],
					}));
					if(list[i]["name"]==item.pushee_default) {
						pushee_default.set({
						'name':list[i]["name"],
						'code':list[i]["code"],
						'sig':list[i]['sig'],
						});
					}
				}
			}
			if(callback) callback.call();
		});
	},
	setPusher:function(id,sig){
		chrome.storage.sync.set({pusher_id:id,pusher_sig:sig},function(){
			pusher_id=id;
			pusher_sig=sig;
			if(callback) callback.call();
		});
	},
	setDefaultPushee:function(name,callback){
		chrome.storage.sync.set({pushee_default:name},function(){
			pushee_default.set('name',name);
			if(callback) callback.call();
		});
	},
	savePusheeList:function(callback){
		chrome.storage.sync.set({pushee_list:JSON.stringify(pushee_list)},function(){
			if(callback) callback.call();
		});
	},
	setCacheMsg:function(msg,callback){
		chrome.storage.sync.set({cache_msg:msg},function(){
			cache_msg=msg;
			if(callback) callback.call();
		});
	},
	langedTmpl:function(tmplName,vars){
		return _.template($('#'+tmplName).html())(vars);
	},
	ajaxPost:function(url,data,success,error){
		return $.ajax({
			type:'POST',
			url:'https://qpush.me/pusher/'+url,
			data:data,
			dataType:'json',
			timeout:5000,
			cache:false,
			success:function(rd){
				if(success) success.call(null,rd);
			}
		}).error(function(XHR){
			if(XHR.responseText) {
				try{
					data=$.parseJSON(XHR.responseText);
				}
				catch(e){
					data['error']=e;
					console.log(e);
				}
			}
			if(error) error.call(null,data['error']);
		});
	},
	showWelcomeForm:function(referer){
		var obj=new class_welcomeForm();
		$('#stage').html(obj.render().el);
		$('#name').focus();
		PF.gaEvent('welcome','view',referer);
	},
	showPushForm:function(referer){
		var obj=new class_pushForm();
		$('#stage').html(obj.render().el);
		var length=$('#msg').val().length;
		$('#msg').focus().get(0).setSelectionRange(length,length);
		PF.gaEvent('push','view',referer);
	},
	showSettingPage:function(referer){
		var obj=new class_settingPage({model:new class_settingData()});
		$('#stage').html(obj.render().el);
		PF.gaEvent('setting','view',referer);
	},
	getPusheeSigByName:function(name){
		var pushee=pushee_list.where({name:name});
		if(pushee)
			return pushee[0].get('sig');
		else
			return null;
	},
	isUrl:function(url){
		return url && url!='chrome://newtab/';
	},
	truncateName:function(name){
		if(name.length<=13) return name;
		return name.substr(0,13)+'...';
	},
	showModal:function(type){
		$('.modalMask').show();
		$('#msg_sending,#msg_success').hide();
		if($('.modalStage').css('display')!='none'){
			$('#msg_'+type).fadeIn(700);
		}
		else{
			$('#msg_'+type).show();
			$('.modalStage').fadeIn(700);
		}
	},
	hideModal:function(){
		$('.modalMask,.modalStage').hide();
	},
	showPageModal:function(type){ // context用
		chrome.tabs.insertCSS(null,{
			file:'/css/context.css'
		});
		chrome.tabs.executeScript(null,{
			file:'/js/context_showModal.js'
		},function(){
			chrome.tabs.executeScript(null,{
				code:'showMsg("msg_'+type+'")'
			});
		});
	},
	hidePageModal:function(){ // context用
		chrome.tabs.executeScript(null,{
			code: 'document.body.removeChild(document.getElementById("qpush_modal"));'
		}); 
	},
	closeWindow:function(){
		window.close();
	},
	indexOfPushee:function(name){
		var list=pushee_list.pluck('name');
		for(var i in list){
			list[i]=list[i].toLowerCase();
		}
		return _.indexOf(list,name.toLowerCase());
	},
	getExtVersion:function(){
		return chrome.app.getDetails().version;
	},
	getChromeVersion:function(){
		var match=window.navigator.userAgent.match(/Chrome\/([\d\.]+) /);
		return match[1];
	},
	gaEvent:function(category,action,label,value){
		_gaq.push(['_trackEvent',category,action,label,value]);
		if(action=='view'){
			_gaq.push(['_trackPageview', category]);
		}
		//ga('send','event',category,action,label,value);
	}
};

	var class_welcomeForm=Backbone.View.extend({
		events:{
			"submit form"	: "savePushee",
			"click a#submit"	: "savePushee",
		},
		render:function(){
			this.$el.html(PF.langedTmpl('welcomeForm'));
			return this;
		},
		savePushee:function(e){
			e.preventDefault();
			PF.gaEvent('welcome','click','submit');

			var name=this.$('#name').val();
			var code=this.$('#code').val();
			var errmsg=this.$('.errmsg');
			errmsg.html('');

			// 欄位檢查
			if(!name && !code){
				errmsg.html(chrome.i18n.getMessage('error__both_required'));
				return false;
			}
			if(!name){
				errmsg.html(chrome.i18n.getMessage('error__name_required'));
				return false;
			}
			if(!code){
				errmsg.html(chrome.i18n.getMessage('error__code_required'));
				return false;
			}

			PF.ajaxPost('checkphone/',{
				'pusher_id':pusher_id,
				'type':PUSHER_TYPE,
				'version_client':PF.getChromeVersion(),
				'version_app':PF.getExtVersion(),
				'name':name,
				'code':code,
			},function(rd){
				if(rd.pusherData){
					PF.setPusher(rd.pusherData.id,rd.pusherData.sig);
				}

				var pushee=pushee_list.where({name:name});
				if(pushee.length>0)
					pushee[0].set({name:name,code:code,sig:rd.pusheeSig});
				else
					pushee_list.add(new class_pushee({name:name,code:code,sig:rd.pusheeSig}));
				PF.savePusheeList(function(){
					PF.setDefaultPushee(name,function(){
						PF.showPushForm('welcome');
					});
				});
				PF.gaEvent('welcome','submit','success');
			},function(err){
				if(err && err.pusherData){
					PF.setPusher(err.pusherData.id,err.pusherData.sig);
				}
				var msg=(err && err.type=='auth')?chrome.i18n.getMessage('error__invalid_name_or_code'):chrome.i18n.getMessage('error__connection')
				errmsg.html(msg);
				PF.gaEvent('welcome','submit','failed-'+(err&&err.type=='auth'?'auth':err));
			});
		}
	});

	var class_pushForm=Backbone.View.extend({
		events:{
			// form
			"click #toSetting"	: "showSetting",
			"click #pusheelist a[data-pushee]"	: "changePushee",
			"click #addPushee"	: "showSetting",
			"click #btn_url"	: "sendUrl",
			"keypress textarea"	: "limitMsgLength",
			"keydown textarea"	: "detectCtrlEnter",
			"keyup textarea"	: "switchSubmitButton",
			"paste"				: "switchSubmitButton",
			"submit form"		: "sendMsg",
			"click a#submit"	: "sendMsg",

			// error page
			"click .back a"		: "hideErrorPage",
			"click .btn_back"	: "hideErrorPage",
			"click .btn_setting": "showSetting",
		},
		render:function(){
			var obj=this;
			chrome.tabs.getSelected(null,function(tab){
				if(!PF.isUrl(tab.url)){
					obj.$('#btn_url').attr('disabled',true);
					obj.$('#btn_url span').html(chrome.i18n.getMessage('no_url'));
				}
			});
			this.$el.html(PF.langedTmpl('pushForm',{
				defaultName:pushee_default.get('name')?pushee_default.get('name'):pushee_list.at(0).get('name')
			}));
			if(!cache_msg){
				this.$('#submit').attr('disabled',true);
			}
			this.$('#pushee,#setting,#mailto').tooltip();
			return this;
		},
		showSetting:function(e){
			e.preventDefault();
			PF.showSettingPage($(e.target).data('ga'));
		},
		changePushee:function(e){
			e.preventDefault();
			var pusheeName=$(e.target).data('pushee');

			if(this.$('#pusheeName').data('pushee')!=pusheeName){
				PF.gaEvent('push','change_pushee');
			}

			this.$('#pusheeName')
			.data('pushee',pusheeName)
			.html(PF.truncateName(pusheeName));
		},
		limitMsgLength:function(e){
			var length=$('#msg').val().length;
			if(length>=MAX_MSG_LENGTH) {
				e.preventDefault();
				this.$('.errmsg').html(chrome.i18n.getMessage('max_length_exceeded',[MAX_MSG_LENGTH]));
				PF.gaEvent('push','others','text_length');
			}
		},
		detectCtrlEnter:function(e){
			if (e.ctrlKey && e.keyCode == 13) {
				this.sendMsg(e);
			}
		},
		switchSubmitButton:function(){
			var msg=$('#msg').val();
			var length=msg.length;
			if(length>0){
				$('#submit').attr('disabled',false);
				if(length>MAX_MSG_LENGTH) { // 直接大量貼上時會用到
					this.$('#msg').val(this.$('#msg').val().substr(0,MAX_MSG_LENGTH));
					this.$('.errmsg').html(chrome.i18n.getMessage('max_length_exceeded',[MAX_MSG_LENGTH]));
					PF.gaEvent('push','others','text_length',length);
				}
			}
			else{
				$('#submit').attr('disabled',true);
			}
			PF.setCacheMsg(msg);
		},
		sendUrl:function(e){
			PF.gaEvent('push','click','sendurl');
			e.preventDefault();
			var ptr=this;
			chrome.tabs.getSelected(null,function(tab){
				var errmsg=ptr.$('.errmsg');
				errmsg.html('');

				if(!PF.isUrl(tab.url)){
					ptr.$('#btn_url')
					.tooltip({trigger:'manual'})
					.attr('data-original-title',chrome.i18n.getMessage('error__no_url'))
					.tooltip('show');

					setTimeout(function(){
						ptr.$('#btn_url').tooltip('hide');
					},1000);
					return false;
				}
				ptr.send({
					'text':tab.url,
					'type':'url',
					'extra':{
						'title':tab.title
					}
				});
			});
		},
		sendMsg:function(e){
			PF.gaEvent('push','click','sendtext');
			e.preventDefault();
			var msg=this.$('#msg').val().trim();
			var errmsg=this.$('.errmsg');
			errmsg.html('');
			if(!msg){
				errmsg.html(chrome.i18n.getMessage('please_enter_msg'));
				return false;
			}
			this.send({
				'text':msg
			});
		},
		send:function(msg){
			PF.showModal('sending');
			var ptr=this;
			var name=this.$('#pusheeName').data('pushee')+"";
			PF.ajaxPost('push/',{
				'pusher_id':pusher_id,
				'name':name,
				'sig':PF.getPusheeSigByName(name),
				'msg':msg,
			},function(rd){
				PF.showModal('success');
				setTimeout(function(){
					PF.closeWindow();
				},1200);
				PF.gaEvent('push','submit','success');
				PF.setCacheMsg('');
			},function(err){
				ptr.showErrorPage(err);
				PF.gaEvent('push','submit','failed-'+err);
			});
		},
		showErrorPage:function(err){
			if(err=='auth'){
				$('#page_error .msg').html(chrome.i18n.getMessage('push_error__invalid_name_or_code'));
				$('#page_error .btn_L')
				.removeClass('btn_back').addClass('btn_setting')
				.html(chrome.i18n.getMessage('go_to_setting'));
			}
			else{
				$('#page_error .msg').html(chrome.i18n.getMessage('push_error__connection'));
				$('#page_error .btn_L')
				.removeClass('btn_setting').addClass('btn_back')
				.html(chrome.i18n.getMessage('try_again'));
			}
			this.$('.mailto').tooltip();
			PF.hideModal();
			$('#page_error').show();		
		},
		hideErrorPage:function(){
			$('#page_error').hide();
			//要不要再加Push頁的PV tracking?	
		}
	});

	var class_pushee=Backbone.Model.extend({
	})

	var class_pusheeView=Backbone.View.extend({
		initialize:function() {
			this.listenTo(pushee_default,'change',this.render);
			this.listenTo(this.model,'change',this.render);
			this.listenTo(this.model,'destroy',this.remove);
		},
		events:{
			"mouseenter .pushee_main"	: "showPanel",
			"mouseleave .pushee_main"	: "hidePanel",

			"click .pushee_edit"	: "showEditForm",
			"click .pushee_delete"	: "deleteRow",
			"click .pushee_star"	: "setDefault",

			// form
			"click #submit"			: "savePushee",
			"submit form"			: "savePushee",
			"focus input"			: "hideTooltip",
			"keyup input"			: "hideTooltip",
		},
		render:function(){
			var name=this.model.get('name');
			if(!name){
				sn=pushee_list.length+1;
			}
			else{
				sn=PF.indexOfPushee(name)+1;
			}
			this.$el.html(PF.langedTmpl('setting_pushee',{
				'sn':sn,
				'name':name,
				'type':name==''?'add':'save',
			}));
			if(!name){ // 新增
				this.showEditForm();
			}
			this.$('.space').tooltip({trigger:'manual'});
			this.$('.name').tooltip({trigger:'manual'});
			this.$('.code').tooltip({trigger:'manual'});
			return this;
		},
		showPanel:function(e){
			e.preventDefault();
			this.$('.mpanel').show();
		},
		hidePanel:function(e){
			e.preventDefault();
			this.$('.mpanel').hide();
		},
		showEditForm:function(e){
			if(e) e.preventDefault();
			this.$('.pushee_main,.pushee_star').hide();
			this.$('.pushee_form').show();
			if(e) PF.gaEvent('setting','click','edit'); // e==null時是新增form
		},
		hideEditForm:function(e){
			e.preventDefault();
			this.$('.pushee_form').hide();
			this.$('.pushee_main,.pushee_star').show();
		},
		deleteRow:function(e){
			e.preventDefault();
			if(this.model.get('name')==pushee_default.get('name')){
				// 如果原本是default
				pushee_default.set({name:'',code:'',sig:''});
			}
			this.model.destroy();
			PF.savePusheeList();
			PF.gaEvent('setting','click','delete');
		},
		setDefault:function(e){
			e.preventDefault();
			PF.setDefaultPushee(this.model.get('name'));
			PF.gaEvent('setting','click','star');
		},
		savePushee:function(e){
			e.preventDefault();
			var action=this.model.get('name')==''?'add':'edit';
			PF.gaEvent('setting','click',action+'_submit');

			this.$el.siblings().find('.name,.code,.space').tooltip('hide');
			var ptr=this;
			var name=this.$('.name').val();
			var code=this.$('.code').val();
			if(code=='******') var sig=this.model.get('sig');

			// 欄位檢查
			if(!name){
				this.$('.name').attr('data-original-title',chrome.i18n.getMessage('required')).tooltip('show');
			}
			if(!code){
				this.$('.code').attr('data-original-title',chrome.i18n.getMessage('required')).tooltip('show');
			}
			if(!name || !code)
				return false;

			var index=PF.indexOfPushee(name);
			if(index>=0 && index!=$('.pushee_sn').index(this.$('.pushee_sn'))){
				this.$('.name').attr('data-original-title',chrome.i18n.getMessage('existed')).tooltip('show');
				return false;
			}
			PF.ajaxPost('checkphone/',{
				'pusher_id':pusher_id,
				'name':name,
				'code':code,
				'sig':sig,
			},function(rd){
				if(action=='add'){ //新增
					pushee_list.add(ptr.model);
					if(pushee_list.length<MAX_PUSHEE_COUNT){
						var view=new class_pusheeView({model:new class_pushee({name:'',code:'',sig:''})});
						$('#pusheeList')
						.append(view.render().el)
						.find('.name:last').focus();
					}
					else{ //數量滿了
						$('.msg_max').removeClass('hide');
					}
				}
				else if (ptr.model.get('name')==pushee_default.get('name')){
					// 原本是default, 要把default也改成新名字
					PF.setDefaultPushee(name);
				}
				ptr.model.set({
					name:name,
					code:code,
					sig:rd.pusheeSig
				},{silent:true}).trigger('change');
				PF.savePusheeList();
				PF.gaEvent('setting',action,'success');
			},function(err){
				var msg=(err && err.type=='auth')?chrome.i18n.getMessage('error__invalid_name_or_code'):chrome.i18n.getMessage('error__connection')
				ptr.$('.space').attr('data-original-title',msg).tooltip('show');
				PF.gaEvent('setting',action,'failed-'+(err && err.type=='auth'?'auth':err));
			});
		},
		hideTooltip:function(e){
			this.$el.siblings().find('.name,.code,.space').tooltip('hide'); // 隱藏其他行的tooltip
			$(e.target).tooltip('hide');
			this.$('.space').tooltip('hide');
		},
	})


	var class_pusheeList=Backbone.Collection.extend({
		model:class_pushee,
	})

	var class_settingData=Backbone.Model.extend({
		initialize:function() {
			this.set('pusheelist',pushee_list,{silent:true});
		},
	});

	var class_settingPage=Backbone.View.extend({
		initialize:function() {
			this.listenTo(pushee_list,'remove',this.render);
		},
		events:{
			"click .back"	: "goBack",

			"submit form"	: "savePushee",
			"click a#submit"	: "savePushee",
		},
		render:function(){
			this.$el.html(PF.langedTmpl('settingPage'));
			var list=this.$('#pusheeList');
			_.each(this.model.get('pusheelist').models,function(pushee){
				var view=new class_pusheeView({model:pushee});
				list.append(view.render().el);
			});
			if(this.model.get('pusheelist').length<MAX_PUSHEE_COUNT){
				view=new class_pusheeView({model:new class_pushee({name:'',code:'',sig:''})});
				list.append(view.render().el);
			}
			this.$('.pushee_edit,.pushee_delete,.pushee_star').tooltip();
			return this;
		},
		goBack:function(e){
			e.preventDefault();
			if(pushee_list.length>0)
				PF.showPushForm('setting');
			else{
				PF.showWelcomeForm('setting');
			}
		}
	});

var MAX_PUSHEE_COUNT=5;
var MAX_MSG_LENGTH=10000;
var EMAIL='service@qpush.me';
var PUSHER_TYPE='chromeExt';
var prevTime;
var pusher_id;
var pusher_sig;
var pushee_default=new class_pushee();
var pushee_list=new class_pusheeList();
var cache_msg='';
